package com.arms.api.analysis.requirement.service;

import java.util.List;
import java.util.Map;

import com.arms.api.analysis.requirement.dto.ReqAnalysisAggrDTO;
import com.arms.api.analysis.requirement.vo.ReqAndIssueTotalCountVO;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.util.model.dto.PdServiceAndIsReqDTO;
import com.arms.api.util.model.dto.request.지라이슈_기본_검색_집계_하위_요청;
import com.arms.api.util.model.dto.response.*;
import com.arms.api.util.model.dto.request.ALM_이슈_제품_및_버전_집계_요청;
import com.arms.api.util.model.dto.request.ALM_이슈_일별_제품_및_버전_집계_요청;
import com.arms.egovframework.javaservice.esframework.factory.creator.query.쿼리_생성기;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과_목록_합계;
import org.springframework.data.elasticsearch.core.query.NativeSearchQuery;

public interface ReqAnalysisService {

    버킷_집계_결과_목록_합계 flatAggregation(ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청);

    버킷_집계_결과_목록_합계 normalVersionOnly(Long pdServiceId, 지라이슈_기본_검색_집계_하위_요청 지라이슈_일반_집계_요청);

    ReqAndIssueTotalCountVO topMenuTotalCountWithReqAndSubtask(ReqAnalysisAggrDTO reqAnalysisAggrDTO);

    버킷_집계_결과_목록_합계 일반_버전필터_해결책유무_검색(ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청, String resolution);

    List<버킷_집계_결과> 제품_버전별_담당자_목록(ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청);

    Map<String, 요구사항_지라이슈상태_주별_집계> 요구사항_지라이슈상태_주별_집계(ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청);

    버킷_집계_결과_목록_합계 ALM_이슈_일별_제품_버전_집계_조회(ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청);

    List<AlmIssueEntity> 지라이슈_기준일자별_제품_및_제품버전_업데이트된_이슈조회(ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청);

    List<AlmIssueEntity> 업데이트된_ALM_이슈_기준일별_목록_조회(ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청);

    Map<Long, Map<String, Map<String,List<요구사항_별_업데이트_데이터>>>>  요구사항별_업데이트_능선_데이터(ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청);

    List<버킷_집계_결과> 제품_버전별_요구사항별_담당자_목록(ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청);

    Map<String,List<요구사항_지라이슈키별_업데이트_목록_데이터>> 요구사항_지라이슈키별_업데이트_목록(List<String> 지라키_목록);

    버킷_집계_결과_목록_합계 현황관리_연결이슈_하위이슈_집계(ALM_이슈_제품_및_버전_집계_요청 ALM_이슈_제품_및_버전_집계_요청, Long 요구사항_링크);

    List<AlmIssueEntity> findUpdatedIssues(Long pdServiceId, List<Long> pdServiceVersionLinks, Long yearsAgo);
}
