package com.arms.api.analysis.scope.controller;


import com.arms.api.analysis.scope.dto.ScopeAggrDTO;
import com.arms.api.analysis.scope.dto.ScopeDTO;
import com.arms.api.analysis.scope.service.AnalysisScope;
import com.arms.api.analysis.scope.vo.ReqStatusesByVersionWithAssigneeVO;
import com.arms.api.analysis.scope.vo.TreeBarTop10IssueVO;

import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.util.model.dto.PdServiceAndIsReqDTO;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/engine/analysis-scope")
@Slf4j
@AllArgsConstructor
public class AnalysisScopeController {

    private final AnalysisScope analysisScope;

    @PostMapping("/req-status-and-reqInvolved-unique-assignees-per-version")
    public ResponseEntity<List<ReqStatusesByVersionWithAssigneeVO>> reqStatusesByVersionWithAssignees(
            @RequestBody ScopeDTO scopeDTO) {

        log.info("[AnalysisScopeController :: 버전배열_요구사항_별_상태_및_관여_작업자_수]");

        return ResponseEntity.ok(analysisScope.reqStatusesByVersionWithAssignees(scopeDTO));

    }

    @PostMapping("/tree-bar-top10")
    public ResponseEntity<List<TreeBarTop10IssueVO>> treeBarTop10(
        @RequestBody ScopeAggrDTO scopeAggrDTO
    ) {

        log.info("[AnalysisScopeController :: treeBarTop10]");

        return ResponseEntity.ok(analysisScope.treeBarTop10(scopeAggrDTO));

    }
    @PostMapping("/pdServiceVersions")
    public List<AlmIssueEntity> pdServiceVersions(@RequestBody ScopeDTO scopeDto) throws IOException {

        log.info("AnalysisScopeController :: pdServiceVersions");

        List<AlmIssueEntity> almIssueEntities = analysisScope.pdServiceVersions(scopeDto);
        return almIssueEntities;
    }
}
